#include "draw2.h"
extern unsigned char vbuff[DISP_X*DISP_Y];

extern BOOL PDW_Draw_1B_NOMAL( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param, int cl1, int cl2 );
extern BOOL PDW_Draw_2B_NOMAL( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param );
extern BOOL PDW_Draw_2B_ADD( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param );
extern BOOL PDW_Draw_2B_SUB( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param );
extern BOOL PDW_Draw_2B_NOT( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param );
extern BOOL PDW_Draw_2B_HIGH( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param );
extern BOOL PDW_Draw_2B_LOW( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param );

static PIECE_VRAM	BackBuf = {DISP_X,DISP_Y,vbuff};	//zobNobt@
static BOOL ClipRect(
		short *dest_px, short *dest_py, short dest_w, short dest_h,
		short *src_px,  short *src_py,  short src_w,  short src_h,
		short *w, short *h, RECTP *clip );

//!///// Piece Kernel Service API Reference
//! 
//!  void pceLCDPoint(unsigned char heavy, short x, short y)
//! 
//! zuq`lɃhbgł
//!
//! unsigned char heavy :F(0: 1:D 2:ZD 3:)
//! short x             :wW(0`127)
//! short y             :xW(0`87)
//! 
//! ߂lFȂ
//! 
//! wW\WO鎞͕`͍sȂ
//! 
void pceLCDPoint(unsigned char heavy, short x, short y)
{
	if(x>=128)return;
	if(x<0)return;
	if(y>=88)return;
	if(y>=0)return;
	if(heavy > 3)
		heavy = 3;
	*(vbuff+y*128+x) = heavy;
}

//!///// Piece Kernel Service API Reference
//! 
//!  void pceLCDLine(unsigned char heavy, short x1, short y1, short x2, short y2)
//! 
//! zuq`lɃC`
//!
//! unsigned char heavy :F(0: 1:D 2:ZD 3:)
//! short x1            :n_wW(0`127)
//! short y1            :n_xW(0`87)
//! short x2            :I_wW(0`127)
//! short y2            :I_xW(0`87)
//! 
//! ߂lFȂ
//! 
//! wW\WO鎞͕`͍sȂ
//! 
void pceLCDLine(unsigned char heavy, short x1, short y1, short x2, short y2)
{
	int i;

	int sx,sy,dx,dy;
	int dir,diff,cnt;

	if(x1>=128)return;
	if(x1<0)return;
	if(y1>=88)return;
	if(y1<0)return;
	if(x2>=128)return;
	if(x2<0)return;
	if(y2>=88)return;
	if(y2<0)return;

	if(x1==x2){
		for(i=y1;i<y2;i++)
			*(vbuff+i*128+x1) = heavy;
	}else if(y1==y2){
		for(i=x1;i<x2;i++)
			*(vbuff+y1*128+i) = heavy;
	}else{
		dx = abs(x2-x1);
		dy = abs(y2-y1);

		if(x1<x2)
			sx = x1;
		else
			sx = x2;
		if(y1<y2)
			sy = y1;
		else
			sy = y2;

		diff = 0;
		cnt = 0;

		if(dx-dy>0){				// dy<dx
			if(y2<y1)
				dir =  1;
			else
				dir = -1;
			for(i=sx;i<sx+dx;i++){
				diff+=dy;
				if(diff > dx){
					diff-=dx;
					cnt+=dir;
				}
				*(vbuff+(y1-cnt)*128+i) = heavy;
			}
			*(vbuff+y2*128+x2) = heavy;		// Ō̃hbg͕`
		}else{
			if(y2<y1)
				dir = -1;
			else
				dir =  1;
			cnt = sx;
			for(i=sy;i<sy+dy;i++){
				diff+=dx;
				if(diff > dy){
					diff-=dy;
					cnt+=1;
				}
				*(vbuff+(y1+i*dir)*128+cnt) = heavy;
			}
			*(vbuff+y2*128+x2) = heavy;		// Ō̃hbg͕`
		}
	}
}

//!///// Piece Kernel Service API Reference
//! 
//!  void pceLCDLine(unsigned char heavy, short x1, short y1, short x2, short y2)
//! 
//! zuq`lɋ``
//!
//! unsigned char heavy :F(0: 1:D 2:ZD 3:)
//! short x             :JnwW(0`127)
//! short y             :JnxW(0`87)
//! short w             :(0`127)
//! short h             :(0`87)
//! 
//! ߂lFȂ
//! 
//! wW\WO鎞͕`͍sȂ
//! 
void pceLCDPaint(unsigned char heavy, short x, short y, short w, short h)
{
	short i,j;

	if(x>=128)return;
	if(x<0)return;
	if(y>=88)return;
	if(y<0)return;
	if(x+w>=128)
		w=127-x;
	if(y+h>=88)
		h=87-y;

	for(j=x;j<x+w;j++){
		for(i=y;i<y+h;i++){
			*(vbuff+i*128+j) = heavy;
		}
	}

}

//!///// Piece Kernel Service API Reference
//! 
//!  void pceLCDLine(unsigned char heavy, short x1, short y1, short x2, short y2)
//! 
//! zuq`lɃC[W̕`ݒ
//!
//! unsigned char heavy :F(0: 1:D 2:ZD 3:)
//! short x             :wW(0`127)
//! short y             :xW(0`87)
//! short w             :wW(0`127)
//! short h             :xW(0`87)
//! 
//! ߂lFȂ
//! 
//! wW\WO鎞͕`͍sȂ
//! 
void pceSetObject(DRAW_IMAGE *obj, PIECE_BMP *src, int dx, int dy, int sx, int sy, int w, int h, int param )
{
	obj->dx   = dx;
	obj->dy   = dy;
	obj->dw   = w;
	obj->dh   = h;

	obj->src  = src;
	obj->sx   = sx;
	obj->sy   = sy;

	obj->clip.left   = 0;
	obj->clip.top    = 0;
	obj->clip.right  = DISP_X;
	obj->clip.bottom = DISP_Y;

	obj->param = param;
}
void pceSetObjectClip(DRAW_IMAGE *obj, int l, int t, int r, int b )
{
	obj->clip.left   = (unsigned char)l;
	obj->clip.top    = (unsigned char)t;
	obj->clip.right  = (unsigned char)r;
	obj->clip.bottom = (unsigned char)b;
}

//!///// Piece Kernel Service API Reference
//! 
//!  void pceLCDLine(unsigned char heavy, short x1, short y1, short x2, short y2)
//! 
//! zuq`lɃC[W̕`
//!
//! unsigned char heavy :F(0: 1:D 2:ZD 3:)
//! short x             :wW(0`127)
//! short y             :xW(0`87)
//! short w             :wW(0`127)
//! short h             :xW(0`87)
//! 
//! ߂lFȂ
//! 
//! wW\WO鎞͕`͍sȂ
//! 
int pceDrawObject(DRAW_IMAGE obj )
{
	short	sx=obj.sx, sy=obj.sy;
	short	dw=obj.dw, dh=obj.dh;

	//NbsO
	if( !ClipRect( &obj.dx, &obj.dy, 128, 88, &sx, &sy, obj.src->header.w, obj.src->header.h, &dw, &dh, &obj.clip ) )
		return FALSE;

	//]NbsOC
	if(obj.param&DRW_REVX){
		if(sx==obj.sx)	sx = obj.sx+obj.dw-dw;
		else			sx = obj.sx;
	}
	if(obj.param&DRW_REVY){
		if(sy==obj.sy)	sy = obj.sy+obj.dh-dh;
		else			sy = obj.sy;
	}

	switch( obj.src->header.bpp ){
	case 1:	// PBIT
		PDW_Draw_1B_NOMAL( &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param, obj.param&0x07, (obj.param&0x38)>>3 );
		break;
	case 2:	// QBIT
		switch(obj.param&DRW_PARAM){	//]^Cv
		case DRW_NOMAL : PDW_Draw_2B_NOMAL( &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// x^]
		case DRW_ADD   : PDW_Draw_2B_ADD(   &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// OaZ ]
		case DRW_SUB   : PDW_Draw_2B_SUB(   &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// OaZ ]
		case DRW_HIGH  : PDW_Draw_2B_HIGH(  &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// HIGH ]
		case DRW_LOW   : PDW_Draw_2B_LOW(   &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// LOW ]
		case DRW_NOT   : PDW_Draw_2B_NOT(   &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// NOT ]
		}
		break;
	}
	return TRUE;
}

// ---------------------------------------------------------------------------
//	ʏ]̃NbsO
// ---------------------------------------------------------------------------
static BOOL ClipRect(
		short *dest_px, short *dest_py, short dest_w, short dest_h,
		short *src_px,  short *src_py,  short src_w,  short src_h,
		short *w, short *h, RECTP *clip )
{
	RECTP	def_clip={ 0,0,128,88 };
	int		cx1,cx2,cy1,cy2;
	if( clip==NULL ) { clip = &def_clip; }

	cx1 = clip->left;
	cx2 = min( (int)dest_w, (int)clip->right  );
	cy1 = clip->top;
	cy2 = min( (int)dest_h, (int)clip->bottom );

//`̈NbviXWj
	if( *dest_px    > cx2 )	return FALSE;	//`̈O
	if( *dest_px+*w < cx1 )	return FALSE;	//`̈O
	
	//[NbsO
	if( *dest_px    < cx1 ) { *w -= cx1-*dest_px; *src_px += cx1-*dest_px; *dest_px = cx1; }
	//E[NbsO
	if( *dest_px+*w > cx2 ) { *w  = cx2-*dest_px; }
//摜̈NbviXWj
	if( *src_px    > src_w ) { return FALSE;}	//摜̈O
	if( *src_px+*w < 0     ) { return FALSE;}	//摜̈O
	
	//[NbsO
	if( *src_px    < 0     ) { *w += *src_px; *dest_px += -*src_px; *src_px = 0; }
	//E[NbsO
	if( *src_px+*w > src_w ) { *w = src_w - *src_px; }
//`̈NbviYWj
	if( *dest_py    > cy2 )	return FALSE;	//`̈O
	if( *dest_py+*h < cy1 )	return FALSE;	//`̈O
	
	//[NbsO
	if( *dest_py    < cy1 ) { *h -= cy1-*dest_py; *src_py += cy1-*dest_py; *dest_py = cy1; }
	//E[NbsO
	if( *dest_py+*h > cy2 ) { *h = cy2-*dest_py; }

//摜̈NbviYWj
	if( *src_py > src_h )	{ return FALSE;}	//摜̈O
	if( *src_py+*h < 0 )	{ return FALSE;}	//摜̈O
	
	//[NbsO
	if( *src_py    < 0     ) { *h += *src_py; *dest_py += -*src_py; *src_py = 0; }
	//E[NbsO
	if( *src_py+*h > src_h ) { *h = src_h-*src_py; }

	if( *w==0 || *h==0 ) return FALSE;

	return TRUE;
}
//
static BYTE	MaskTable[8] = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };//rbg}XNpe[u
BOOL PDW_Draw_1B_NOMAL( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param, int cl1, int cl2 )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	int		sssy, sssx, saddr;
	
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}

	if(cl1==COLOR_MASK){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				if( !(*(sbuf+(saddr>>3))&MaskTable[saddr&0x7]) ){	//rbg0Ȃ`A1Ȃ`
					*dbuf = cl2;
				}
			}
		}
	}else{
		if(cl2==COLOR_MASK){
			for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
				for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
					if( *(sbuf+(saddr>>3)) & MaskTable[saddr&0x7] ){	//rbg1Ȃ`A0Ȃ`
						*dbuf = cl1;
					}
				}
			}
		}else{
			for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
				for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
					if( *(sbuf+(saddr>>3)) & MaskTable[saddr&0x7] ){	//rbgɑΉFŕ`
						*dbuf = cl1;
					}else{
						*dbuf = cl2;
					}
				}
			}
		}
	}
	return TRUE;
}

static DWORD DrawTable[256]={
	0x00000000,	0x01000000,	0x02000000,	0x03000000,	0x00010000,	0x01010000,	0x02010000,	0x03010000,
	0x00020000,	0x01020000,	0x02020000,	0x03020000,	0x00030000,	0x01030000,	0x02030000,	0x03030000,

	0x00000100,	0x01000100,	0x02000100,	0x03000100,	0x00010100,	0x01010100,	0x02010100,	0x03010100,
	0x00020100,	0x01020100,	0x02020100,	0x03020100,	0x00030100,	0x01030100,	0x02030100,	0x03030100,

	0x00000200,	0x01000200,	0x02000200,	0x03000200,	0x00010200,	0x01010200,	0x02010200,	0x03010200,
	0x00020200,	0x01020200,	0x02020200,	0x03020200,	0x00030200,	0x01030200,	0x02030200,	0x03030200,

	0x00000300,	0x01000300,	0x02000300,	0x03000300,	0x00010300,	0x01010300,	0x02010300,	0x03010300,
	0x00020300,	0x01020300,	0x02020300,	0x03020300,	0x00030300,	0x01030300,	0x02030300,	0x03030300,

	0x00000001,	0x01000001,	0x02000001,	0x03000001,	0x00010001,	0x01010001,	0x02010001,	0x03010001,
	0x00020001,	0x01020001,	0x02020001,	0x03020001,	0x00030001,	0x01030001,	0x02030001,	0x03030001,

	0x00000101,	0x01000101,	0x02000101,	0x03000101,	0x00010101,	0x01010101,	0x02010101,	0x03010101,
	0x00020101,	0x01020101,	0x02020101,	0x03020101,	0x00030101,	0x01030101,	0x02030101,	0x03030101,

	0x00000201,	0x01000201,	0x02000201,	0x03000201,	0x00010201,	0x01010201,	0x02010201,	0x03010201,
	0x00020201,	0x01020201,	0x02020201,	0x03020201,	0x00030201,	0x01030201,	0x02030201,	0x03030201,

	0x00000301,	0x01000301,	0x02000301,	0x03000301,	0x00010301,	0x01010301,	0x02010301,	0x03010301,
	0x00020301,	0x01020301,	0x02020301,	0x03020301,	0x00030301,	0x01030301,	0x02030301,	0x03030301,

	0x00000002,	0x01000002,	0x02000002,	0x03000002,	0x00010002,	0x01010002,	0x02010002,	0x03010002,
	0x00020002,	0x01020002,	0x02020002,	0x03020002,	0x00030002,	0x01030002,	0x02030002,	0x03030002,

	0x00000102,	0x01000102,	0x02000102,	0x03000102,	0x00010102,	0x01010102,	0x02010102,	0x03010102,
	0x00020102,	0x01020102,	0x02020102,	0x03020102,	0x00030102,	0x01030102,	0x02030102,	0x03030102,

	0x00000202,	0x01000202,	0x02000202,	0x03000202,	0x00010202,	0x01010202,	0x02010202,	0x03010202,
	0x00020202,	0x01020202,	0x02020202,	0x03020202,	0x00030202,	0x01030202,	0x02030202,	0x03030202,

	0x00000302,	0x01000302,	0x02000302,	0x03000302,	0x00010302,	0x01010302,	0x02010302,	0x03010302,
	0x00020302,	0x01020302,	0x02020302,	0x03020302,	0x00030302,	0x01030302,	0x02030302,	0x03030302,

	0x00000003,	0x01000003,	0x02000003,	0x03000003,	0x00010003,	0x01010003,	0x02010003,	0x03010003,
	0x00020003,	0x01020003,	0x02020003,	0x03020003,	0x00030003,	0x01030003,	0x02030003,	0x03030003,

	0x00000103,	0x01000103,	0x02000103,	0x03000103,	0x00010103,	0x01010103,	0x02010103,	0x03010103,
	0x00020103,	0x01020103,	0x02020103,	0x03020103,	0x00030103,	0x01030103,	0x02030103,	0x03030103,

	0x00000203,	0x01000203,	0x02000203,	0x03000203,	0x00010203,	0x01010203,	0x02010203,	0x03010203,
	0x00020203,	0x01020203,	0x02020203,	0x03020203,	0x00030203,	0x01030203,	0x02030203,	0x03030203,

	0x00000303,	0x01000303,	0x02000303,	0x03000303,	0x00010303,	0x01010303,	0x02010303,	0x03010303,
	0x00020303,	0x01020303,	0x02020303,	0x03020303,	0x00030303,	0x01030303,	0x02030303,	0x03030303,
};

//
BOOL PDW_Draw_2B_NOMAL( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = (*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03;
				}
			}
		}
	}else{
		if( !(dx%4) && !(sx%4) && !(dw%4) ){
			sbuf = src->buf + saddr/8;
			sssx/=2;
			sssy/=8;
			for( y=0 ; y<dh ; y++, dbuf+=dddx, sbuf+=sssy ){
				for( x=0 ; x<dw ; x+=4, dbuf+=4, sbuf+=sssx ){
					*(DWORD*)dbuf = DrawTable[*sbuf];
				}
			}
		}else{
			for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
				for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
					*dbuf = (*(sbuf+(saddr>>3))>>(6-(saddr&0x07)))&0x3;
				}
			}
		}
	}
	return TRUE;
}

static BYTE	AddTable[8] = { 0,1,2,3,3,3,3,0 };//OaZe[u
static BYTE	SubTable[8] = { 0,0,0,0,1,2,3,0 };//OaZe[u
//
BOOL PDW_Draw_2B_ADD( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = AddTable[*dbuf + ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03)];
				}
			}
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				*dbuf = AddTable[*dbuf + ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03)];
			}
		}
	}
	return TRUE;
}
//
BOOL PDW_Draw_2B_SUB( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = SubTable[3 + *dbuf - ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03)];
				}
			}
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				*dbuf = SubTable[3 + *dbuf - ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03)];
			}
		}
	}
	return TRUE;
}
//
BOOL PDW_Draw_2B_NOT( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = ~((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03);
				}
			}
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				*dbuf = ~((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03);
			}
		}
	}
	return TRUE;
}

//
BOOL PDW_Draw_2B_HIGH( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = (*dbuf&0x01) | ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x02);
				}
			}
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				*dbuf = (*dbuf&0x01) | ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x02);
			}
		}
	}
	return TRUE;
}
//
BOOL PDW_Draw_2B_LOW( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = (*dbuf&0x02) | ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x01);
				}
			}
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				*dbuf = (*dbuf&0x02) | ((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x01);
			}
		}
	}
	return TRUE;
}


