//------------------------------------------------------------------------
 //  Project Name   :  Project PIECE
  //  File Name      :  PIECE_DRAW.c
   //  Copyright      :  AQUA (Leaf)  since 2001 - 
    //                                 Programd by.  Miyakusa Masakazu
     //------------------------------------------------------------------------
      // PIECE`惉Cu

//#include <string.h>

#ifdef _WIN32
	#include "WIN_Std.h"
	#include "P2W_Std.h"
	#include "P2W_Draw.h"
	#include "decode.h"
#else
	#include <piece.h>
	#include "system.h"
	#include "mem_ctrl.h"
	#include "decode.h"
#endif


#include "PIECE_Draw.h"
#include "PIECE_Ex.h"
#include "FilePack.h"


//+=+=+=+ VRAMǗ =+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

static PIECE_VRAM	BackBuf;	//zobNobt@
static PIECE_BMP	Vram1B;		//mNQl(1BIT)VRAM
static PIECE_BMP	Vram2B;		//mNSK(2BIT)VRAM
static PIECE_BMP	Vram2BM;	//mNSK}XNt(2+1BIT)VRAM

//zVRAM쐬
BOOL PDW_InitPieceVram( BYTE *back_buf,
					    BYTE *mono1,  int w1,  int h1,
						BYTE *mono2,  int w2,  int h2,
						BYTE *mono2m, int w2m, int h2m )
{
	BackBuf.buf = back_buf;
	BackBuf.w = SCREEN_W;
	BackBuf.h = SCREEN_H;
	memset2( back_buf, COLOR_WHITE, SCREEN_W*SCREEN_H);

	Vram1B.header.head    = DWORD_CHAR('P','B','M','P');		//	HEADER   'PBMP'
	Vram1B.header.fsize   = sizeof(PBMP_FILEHEADER) + w1*h1/8;	//	t@C iBYTEPʁj
	Vram1B.header.bpp     = 1;			//	bit[x  i2j
	Vram1B.header.mask    = 0;			//	}XNbit[x  i1j
	Vram1B.header.w       = w2;			//	X		SsNZPʌ
	Vram1B.header.h       = h2;			//	Y		
	Vram1B.header.buf_size= w2*h2/8;	//	BMPTCY	iBYTEPʁj
	Vram1B.buf  = mono1;
	Vram1B.mask = NULL;

	Vram2B.header.head    = DWORD_CHAR('P','B','M','P');		//	HEADER   'PBMP'
	Vram2B.header.fsize   = sizeof(PBMP_FILEHEADER) + w2*h2*2/8;	//	t@C iBYTEPʁj
	Vram2B.header.bpp     = 2;			//	bit[x  i2j
	Vram2B.header.mask    = 0;			//	}XNbit[x  i1j
	Vram2B.header.w       = w2;			//	X		SsNZPʌ
	Vram2B.header.h       = h2;			//	Y		
	Vram2B.header.buf_size= w2*h2*2/8;	//	BMPTCY	iBYTEPʁj
	Vram2B.buf  = mono2;
	Vram2B.mask = NULL;

	Vram2BM.header.head    = DWORD_CHAR('P','B','M','P');	//	HEADER   'PBMP'
	Vram2BM.header.fsize   = sizeof(PBMP_FILEHEADER) + w2m*h2m*3/8;	//	t@C iBYTEPʁj
	Vram2BM.header.bpp     = 2;			//	bit[x  i2j
	Vram2BM.header.mask    = 1;			//	}XNbit[x  i1j
	Vram2BM.header.w       = w2m;		//	X		SsNZPʌ
	Vram2BM.header.h       = h2m;		//	Y		
	Vram2BM.header.buf_size= w2m*h2m*3/8;	//	BMPTCY	iBYTEPʁj
	Vram2BM.buf  = mono2m;
	Vram2BM.mask = mono2m + w2m*h2m*2/8;
	return TRUE;
}
//zVRAMI
BOOL PDW_TremPieceVram( void )
{
	if( BackBuf.buf ){
		memset2( &BackBuf, 0, sizeof(PIECE_VRAM) );
		return TRUE;
	}else{
		return FALSE;
	}
}
//zVRAM擾
PIECE_VRAM *PDW_GetPieceVram( void )
{
	return &BackBuf;
}

//+=+=+=+=+= 摜̃[h +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

//1BIT摜̃[h
BOOL PDW_Load_1B_Onmemory( BYTE *data, int x, int y )
{
	PBMP_FILEHEADER	pbhead = *(PBMP_FILEHEADER *)data;
	int				yy, fptr, vptr;

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return FALSE;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=1)	return FALSE;		//2BIT̂
	if(pbhead.mask!=0)	return FALSE;		//}XN
	if(pbhead.w%8)		return FALSE;		//8P
	if(x%8)				return FALSE;		//8P

	for( yy=0; yy<pbhead.h ;yy++ ){
		vptr = (x + (y+yy)*Vram1B.header.w)/8;
		fptr = sizeof(PBMP_FILEHEADER) + yy*pbhead.w/8;
		memcpy2( Vram1B.buf+vptr, data+fptr, pbhead.w/8 );
	}
	return TRUE;
}
//2BIT摜̃[h
BOOL PDW_Load_2B_Onmemory( BYTE *data, int x, int y )
{
	PBMP_FILEHEADER	pbhead = *(PBMP_FILEHEADER *)data;
	int				yy, fptr, vptr;

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return FALSE;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=2)	return FALSE;		//2BIT̂
	if(pbhead.mask!=0)	return FALSE;		//}XN
	if(pbhead.w%4)		return FALSE;		//8P
	if(x%4)				return FALSE;		//8P

	for( yy=0; yy<pbhead.h ;yy++ ){
		vptr = (x + (y+yy)*Vram2B.header.w)/4;
		fptr = sizeof(PBMP_FILEHEADER) + yy*pbhead.w/4;
		memcpy2( Vram2B.buf+vptr, data+fptr, pbhead.w/4 );
	}
	return TRUE;
}

//2BIT+MASK摜̃[h
BOOL PDW_Load_2BM_Onmemory( BYTE *data, int x, int y )
{
	PBMP_FILEHEADER	pbhead = *(PBMP_FILEHEADER *)data;
	BYTE			*src   = data + sizeof(PBMP_FILEHEADER);
	BYTE			*smask = data + sizeof(PBMP_FILEHEADER) + pbhead.h*(pbhead.w/4);
	BYTE			*dst   = Vram2BM.buf  + (y*Vram2BM.header.w + x)/4;
	BYTE			*dmask = Vram2BM.mask + (y*Vram2BM.header.w + x)/8;
	int				yy;
	int				w1 = pbhead.w/4;
	int				w2 = pbhead.w/8;
	int				w3 = (pbhead.w+4)/8;
	int				ww = pbhead.w%8;
	int				dw1 = Vram2BM.header.w/4;
	int				dw2 = Vram2BM.header.w/8;

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return 1;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=2)	return 2;		//2BIT̂
	if(pbhead.mask!=1)	return 3;		//}XN
	if(pbhead.w%4)		return 4;		//8P
	if(x%8)				return 5;		//8P

	for( yy=0; yy<pbhead.h ;yy++, dst+=dw1, src+=w1, dmask+=dw2, smask+=w3 ){
		memcpy2( dst, src, w1 );
		memcpy2( dmask, smask, w2 );
		if(ww)	*(dmask+w2) = (*(dmask+w2)&0x0f) | (*(smask+w2)&0xf0);
	}
	return 0;
}
//2BIT+MASK摜 2BITVRAMɃ[h
BOOL PDW_Load_2BM_2B_Onmemory( BYTE *data, int x, int y, int mask_bit )
{
	PBMP_FILEHEADER	pbhead = *(PBMP_FILEHEADER *)data;
	BYTE			*src   = data + sizeof(PBMP_FILEHEADER);
	BYTE			*smask = data + sizeof(PBMP_FILEHEADER) + pbhead.h*(pbhead.w/4);
	BYTE			*dst   = Vram2B.buf  + (y*Vram2B.header.w + x)/4;
	int				xx,yy;
	int				w1 = pbhead.w/4;
	int				w3 = (pbhead.w+4)/8;
	int				dw1 = Vram2B.header.w/4;

	for( yy=0; yy<pbhead.h ;yy++, dst+=dw1, src+=w1, smask+=w3 ){
		memcpy2( dst, src, w1 );
		for( xx=0 ; xx<pbhead.w ; xx++ ){
			if( !PIECE_GetBit( smask, 1, xx ) ){
				PIECE_SetBit( dst, 2, xx, mask_bit );
			}
		}
	}
	return TRUE;
}

#ifdef _WIN32
BYTE	FileWork1[8096];
BYTE	FileWork2[8096];
#endif
//1BIT摜̃[h
BOOL PDW_Load_1B( char *fname, int x, int y )
{
	BYTE	*faddr;
	PBMP_FILEHEADER	pbhead;
	int	yy, fptr, vptr;
#ifdef _WIN32
	char	fname2[256];
	faddr = FileWork1;

	wsprintf( fname2, "grp\\%s", fname );
	if( !P2W_ReadFileMax( fname2, FileWork2 ) ) return FALSE;
	decode( faddr, FileWork2 );
#else
	faddr = FILE_WORK;

	if( !FPK_FindPackFile( "odemaru.grp", fname, FILE_WORK2 ) ) return FALSE;
	decode( faddr, FILE_WORK2 );
#endif
	pbhead = *(PBMP_FILEHEADER*)faddr;

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return FALSE;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=1)	return FALSE;		//2BIT̂
	if(pbhead.mask!=0)	return FALSE;		//}XN
	if(pbhead.w%8)		return FALSE;		//8P
	if(x%8)				return FALSE;		//8P

	for( yy=0; yy<pbhead.h ;yy++ ){
		vptr = (y*Vram1B.header.w + x + yy*Vram1B.header.w)/8;
		fptr = sizeof(PBMP_FILEHEADER) + yy*pbhead.w/8;

		memcpy( Vram1B.buf+vptr, faddr+fptr, pbhead.w/8 );
	}

	return TRUE;
}
//2BIT摜̃[h
BOOL PDW_Load_2B( char *fname, int x, int y )
{
	BYTE	*faddr;
	PBMP_FILEHEADER	pbhead;
	int	yy, fptr, vptr;
#ifdef _WIN32
	char	fname2[256];
	faddr = FileWork1;

	wsprintf( fname2, "grp\\%s", fname );
	if( !P2W_ReadFileMax( fname2, FileWork2 ) ) return FALSE;
	decode( faddr, FileWork2 );
#else
	faddr = FILE_WORK;

	if( !FPK_FindPackFile( "odemaru.grp", fname, FILE_WORK2 ) ) return FALSE;
	decode( faddr, FILE_WORK2 );
#endif
	pbhead = *(PBMP_FILEHEADER*)faddr;

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return FALSE;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=2)	return FALSE;		//2BIT̂
	if(pbhead.mask!=0)	return FALSE;		//}XN
	if(pbhead.w%4)		return FALSE;		//SP
	if(x%4)				return FALSE;		//SP

	for( yy=0; yy<pbhead.h ;yy++ ){
		vptr = (y*Vram2B.header.w + x + yy*Vram2B.header.w)/4;
		fptr = sizeof(PBMP_FILEHEADER) + yy*pbhead.w/4;

		memcpy( Vram2B.buf+vptr, faddr+fptr, pbhead.w/4 );
	}
	return TRUE;
}
//2BIT+MASK摜̃[h
BOOL PDW_Load_2BM( char *fname, int x, int y )
{
	BYTE	*faddr;
	PBMP_FILEHEADER	pbhead;
	BYTE	*dst   = Vram2BM.buf  + (y*Vram2BM.header.w + x)/4;
	BYTE	*dmask = Vram2BM.mask + (y*Vram2BM.header.w + x)/8;
	int		yy, w1, w2, ww;

#ifdef _WIN32
	char	fname2[256];
	faddr = FileWork1;

	wsprintf( fname2, "grp\\%s", fname );
	if( !P2W_ReadFileMax( fname2, FileWork2 ) ) return FALSE;
	decode( faddr, FileWork2 );
#else
	faddr = FILE_WORK;

	if( !FPK_FindPackFile( "odemaru.grp", fname, FILE_WORK2 ) ) return FALSE;
	decode( faddr, FILE_WORK2 );
#endif
	pbhead = *(PBMP_FILEHEADER*)faddr;
	faddr += sizeof(PBMP_FILEHEADER);

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return FALSE;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=2)	return FALSE;		//2BIT̂
	if(pbhead.mask!=1)	return FALSE;		//1BIT̂
	if(pbhead.w%4)		return FALSE;		//8P
	if(x%8)				return FALSE;		//8P

	//sNZ
	w1 = Vram2BM.header.w/4;
	w2 = pbhead.w/4;
	for( yy=0; yy<pbhead.h ;yy++, dst+=w1 ){
		memcpy( dst, faddr, w2 );
//		memset( dst, 0xff, w2 );
		faddr += w2;
	}
	//}XN
	w1 = Vram2BM.header.w/8;
	w2 = pbhead.w/8;
	ww = pbhead.w%8;
	for( yy=0; yy<pbhead.h ;yy++, dmask+=w1 ){
		memcpy( dmask, faddr, w2 );
//		memset( dst, 0xff, w2 );
		faddr += w2;
		if(ww){
			*(dmask+w2) = (*(dmask+w2)&0x0f) | ((*faddr)&0xf0);
			faddr++;
		}
	}

	return TRUE;
}

//2BIT+MASK摜 2BITVRAMɃ[h
BOOL PDW_Load_2BM_2B( char *fname, int x, int y, int mask_bit )
{
	BYTE	*faddr;
	PBMP_FILEHEADER	pbhead;
	BYTE	*dst   = Vram2B.buf  + (y*Vram2B.header.w + x)/4;
	BYTE	*mask;
	int		xx,yy, w1, w2,w3;

#ifdef _WIN32
	char	fname2[256];
	faddr = FileWork1;

	wsprintf( fname2, "grp\\%s", fname );
	if( !P2W_ReadFileMax( fname2, FileWork2 ) ) return FALSE;
	decode( faddr, FileWork2 );
#else
	faddr = FILE_WORK;

	if( !FPK_FindPackFile( "odemaru.grp", fname, FILE_WORK2 ) ) return FALSE;
	decode( faddr, FILE_WORK2 );
#endif
	pbhead = *(PBMP_FILEHEADER*)faddr;
	faddr += sizeof(PBMP_FILEHEADER);

	if(pbhead.head!=DWORD_CHAR('P','B','M','P')) return FALSE;	//PIECE BMP̋Kił邩H
	if(pbhead.bpp!=2)	return FALSE;		//2BIT̂
	if(pbhead.mask!=1)	return FALSE;		//1BIT̂
	if(pbhead.w%4)		return FALSE;		//8P
	if(x%8)				return FALSE;		//8P

	//sNZ
	//}XN
	w1 = Vram2B.header.w/4;
	w2 = (pbhead.w+4)/8;
	w3 = pbhead.w/4;
	dst = Vram2B.buf  + (y*Vram2B.header.w + x)/4;
	mask = faddr+w3*pbhead.h;

	if(mask_bit<4){
		for( yy=0; yy<pbhead.h ;yy++, dst+=w1, mask+=w2, faddr+=w3 ){
			for( xx=0 ; xx<pbhead.w ; xx++ ){
				if( !PIECE_GetBit( mask, 1, xx ) ){
					PIECE_SetBit( dst, 2, xx, mask_bit );
				}else{
					PIECE_SetBit( dst, 2, xx, PIECE_GetBit(faddr,2,xx) );
				}
			}
		}
	}else{
		for( yy=0; yy<pbhead.h ;yy++, dst+=w1, mask+=w2, faddr+=w3 ){
			for( xx=0 ; xx<pbhead.w ; xx++ ){
				if( PIECE_GetBit( mask, 1, xx ) ){
					PIECE_SetBit( dst, 2, xx, PIECE_GetBit(faddr,2,xx) );
				}
			}
		}
	}
	return TRUE;
}


//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
BOOL ClipRectDest( short *dest_px, short *dest_py, short dest_w, short dest_h, short *w, short *h, RECTP *clip )
{
	RECTP	def_clip={ 0,0,SCREEN_W,SCREEN_H };
	int		cx1,cx2,cy1,cy2;
	if( clip==NULL ) { clip = &def_clip; }

	cx1 = clip->left;
	cx2 = min( dest_w, clip->right  );
	cy1 = clip->top;
	cy2 = min( dest_h, clip->bottom );

//`̈NbviXWj
	if( *dest_px    > cx2 )	return FALSE;	//`̈O
	if( *dest_px+*w < cx1 )	return FALSE;	//`̈O
	//[NbsO
	if( *dest_px    < cx1 ) { *w -= cx1-*dest_px; *dest_px = cx1; }
	//E[NbsO
	if( *dest_px+*w > cx2 ) { *w  = cx2-*dest_px; }

//`̈NbviYWj
	if( *dest_py    > cy2 )	return FALSE;	//`̈O
	if( *dest_py+*h < cy1 )	return FALSE;	//`̈O
	//[NbsO
	if( *dest_py    < cy1 ) { *h -= cy1-*dest_py; *dest_py = cy1; }
	//E[NbsO
	if( *dest_py+*h > cy2 ) { *h = cy2-*dest_py; }

	if( *w==0 || *h==0 ) return FALSE;

	return TRUE;
}
//
// ---------------------------------------------------------------------------
//	ʏ]̃NbsO
// ---------------------------------------------------------------------------
BOOL ClipRect(
		short *dest_px, short *dest_py, short dest_w, short dest_h,
		short *src_px,  short *src_py,  short src_w,  short src_h,
		short *w, short *h, RECTP *clip )
{
	RECTP	def_clip={ 0,0,128,88 };
	int		cx1,cx2,cy1,cy2;
	if( clip==NULL ) { clip = &def_clip; }

	cx1 = clip->left;
	cx2 = min( (int)dest_w, (int)clip->right  );
	cy1 = clip->top;
	cy2 = min( (int)dest_h, (int)clip->bottom );

//`̈NbviXWj
	if( *dest_px    > cx2 )	return FALSE;	//`̈O
	if( *dest_px+*w < cx1 )	return FALSE;	//`̈O
	
	//[NbsO
	if( *dest_px    < cx1 ) { *w -= cx1-*dest_px; *src_px += cx1-*dest_px; *dest_px = cx1; }
	//E[NbsO
	if( *dest_px+*w > cx2 ) { *w  = cx2-*dest_px; }
//摜̈NbviXWj
	if( *src_px    > src_w ) { return FALSE;}	//摜̈O
	if( *src_px+*w < 0     ) { return FALSE;}	//摜̈O
	
	//[NbsO
	if( *src_px    < 0     ) { *w += *src_px; *dest_px += -*src_px; *src_px = 0; }
	//E[NbsO
	if( *src_px+*w > src_w ) { *w = src_w - *src_px; }



//`̈NbviYWj
	if( *dest_py    > cy2 )	return FALSE;	//`̈O
	if( *dest_py+*h < cy1 )	return FALSE;	//`̈O
	
	//[NbsO
	if( *dest_py    < cy1 ) { *h -= cy1-*dest_py; *src_py += cy1-*dest_py; *dest_py = cy1; }
	//E[NbsO
	if( *dest_py+*h > cy2 ) { *h = cy2-*dest_py; }

//摜̈NbviYWj
	if( *src_py > src_h )	{ return FALSE;}	//摜̈O
	if( *src_py+*h < 0 )	{ return FALSE;}	//摜̈O
	
	//[NbsO
	if( *src_py    < 0     ) { *h += *src_py; *dest_py += -*src_py; *src_py = 0; }
	//E[NbsO
	if( *src_py+*h > src_h ) { *h = src_h-*src_py; }

	if( *w==0 || *h==0 ) return FALSE;

	return TRUE;
}

//
BOOL PDW_Draw_2B_HALF( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, PIECE_BMP *src, int sx, int sy, int param )
{
	int		x,y;
	BYTE	*dbuf = dest->buf +dy*dest->w + dx;
	int		dddx = dest->w-dw;
	BYTE	*sbuf = src->buf;
	BYTE	*mask = src->mask;
	int		sssy, sssx, saddr;
	if(param&DRW_REVX){
		sssx = -1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w-dw);	saddr = (sy+dh-1)*src->header.w + sx+dw-1; }
		else				{ sssy = src->header.w+dw;		saddr = sy*src->header.w + sx+dw-1; }
	}else{
		sssx = 1;
		if(param&DRW_REVY)	{ sssy = -(src->header.w+dw);	saddr = (sy+dh-1)*src->header.w + sx; }
		else				{ sssy = src->header.w-dw;		saddr = sy*src->header.w + sx; }
	}
	saddr*=2;
	sssx*=2;
	sssy*=2;

	if(src->header.mask){
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
//				if( ( *(mask+saddr/2/8) >> (7-saddr/2%8) ) & 0x01 ){	//}XNrbgONȂ`AOFFȂ`
				if( *(mask+(saddr>>4)) & (0x80>>((saddr>>1)&0x7)) ){
					*dbuf = (((*(sbuf+(saddr>>3))>>(6-(saddr&0x07))) & 0x03)>>1)+2;
				}
			}
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx, saddr+=sssy ){
			for( x=0 ; x<dw ; x++, dbuf++, saddr+=sssx ){
				*dbuf = (((*(sbuf+(saddr>>3))>>(6-(saddr&0x07)))& 0x03)>>1)+2;
			}
		}
	}
	return TRUE;
}

//`惋[`[g
static int pceDrawObjectEx( DRAW_OBJECT obj )
{
	short	sx=obj.sx, sy=obj.sy;
	short	dw=obj.dw, dh=obj.dh;

	static counter=0;
	counter++;
	//NbsO
	if( !ClipRect( &obj.dx, &obj.dy, 128, 88, &sx, &sy, obj.src->header.w, obj.src->header.h, &dw, &dh, &obj.clip ) )
		return FALSE;

	//]NbsOC
	if(obj.param&DRW_REVX){
		if(sx==obj.sx)	sx = obj.sx+obj.dw-dw;
		else			sx = obj.sx;
	}
	if(obj.param&DRW_REVY){
		if(sy==obj.sy)	sy = obj.sy+obj.dh-dh;
		else			sy = obj.sy;
	}
	switch(obj.param&DRW_PARAM){	//]^Cv
		case DRW_HALF  : PDW_Draw_2B_HALF(   &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param );	break;	// x^]
//		case DRW_LIGHT : PDW_Draw_2B_LIGHT(  &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, counter%16 );	break;	// OaZ ]
//		case DRW_BRIGHT: PDW_Draw_2B_BRIGHT( &BackBuf, obj.dx, obj.dy, dw, dh, obj.src, sx, sy, obj.param, (BYTE)limit(dobj.color1,0,7) );	break;	// OaZ ]
	}
	return TRUE;
}
//`惋[`[g
BOOL PDW_DrawBmp( DRAW_OBJECT2 dobj )
{
	DRAW_OBJECT	image;
	int			param;

	if(!dobj.src) return FALSE;

	if(dobj.src->header.bpp==1){
		param = DRW_CLR( dobj.color1, dobj.color2 );
	}else{
		param = dobj.param;
	}
	if(dobj.rev_x)	param |= DRW_REVX;
	if(dobj.rev_y)	param |= DRW_REVY;

/*
	pceSetObject( &image, dobj.src, dobj.dx, dobj.dy, dobj.sx, dobj.sy, dobj.dw, dobj.dh, param );
	image.clip = dobj.clip;

	if( (dobj.param==DRW_HALF || dobj.param==DRW_LIGHT || dobj.param==DRW_BRIGHT) && dobj.src->header.bpp==2 ){
		pceDrawObjectEx( image );
	}else{
		pceDrawObject( image );
	}
*/
	pceLCDSetObject(&image, dobj.src, dobj.dx, dobj.dy, dobj.sx, dobj.sy, dobj.dw, dobj.dh, param);
	image.clip = dobj.clip;

//	if( (dobj.param==DRW_HALF || dobj.param==DRW_LIGHT || dobj.param==DRW_BRIGHT) && dobj.src->header.bpp==2 ){
//		pceDrawObjectEx( image );
//	}else{
		pceLCDDrawObject( image );
//	}


	return TRUE;
}
//
BOOL PDW_DrawBmpEx( DRAW_OBJECT2 dobj )
{
	DRAW_OBJECT2 dobj2 = dobj;
	BOOL		ret=FALSE;

	dobj2.dh = dobj.sh;

	for( ; dobj2.dy-dobj.dy < dobj.dh ; dobj2.dy+=dobj.sh ){
		dobj2.dw = dobj.sw;
		if( dobj2.dy-dobj.dy + dobj.sh > dobj.dh ){
			dobj2.dh = dobj.dh%dobj.sh;
		}
		for( dobj2.dx=dobj.dx ; dobj2.dx-dobj.dx < dobj.dw ; dobj2.dx+=dobj.sw ){
			if( dobj2.dx-dobj.dx + dobj.sw > dobj.dw ){
				dobj2.dw = dobj.dw%dobj.sw;
			}
			ret |= PDW_DrawBmp( dobj2 );
		}
	}
	return ret;
}
//hԂm[}
BOOL PDW_DrawPaint_NOMAL( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, BYTE color )
{
	int		y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;

	for( y=0 ; y<dh ; y++, dbuf+=dest->w ){
		memset( dbuf, color, dw );
	}
	return TRUE;
}
static BYTE	AddTable[8] = { 0,1,2,3,3,3,3,0 };//OaZe[u
static BYTE	SubTable[8] = { 0,0,0,0,1,2,3,0 };//OaZe[u
//hԂZ
BOOL PDW_DrawPaint_ADD( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, BYTE color )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;

	for( y=0 ; y<dh ; y++, dbuf+=dddx ){
		for( x=0 ; x<dw ; x++, dbuf++ ){ *dbuf = AddTable[*dbuf+color]; }
	}
	return TRUE;
}
//hԂZ
BOOL PDW_DrawPaint_SUB( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, BYTE color )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;

	for( y=0 ; y<dh ; y++, dbuf+=dddx ){
		for( x=0 ; x<dw ; x++, dbuf++ ){ *dbuf = SubTable[3+*dbuf-color]; }
	}
	return TRUE;
}
//hԂʃrbg
BOOL PDW_DrawPaint_HIGH( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, BYTE color )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;
	int		dw2 = dw/4;
	int		dw3 = dw%4;

	if( 0x02&color ){
		for( y=0 ; y<dh ; y++, dbuf+=dddx ){
			for( x=0 ; x<dw2 ; x++, dbuf+=4 ) *(DWORD*)dbuf = *(DWORD*)dbuf|0x02020202;
			for( x=0 ; x<dw3 ; x++, dbuf++ )  *dbuf = *dbuf|0x02;
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx ){
			for( x=0 ; x<dw2 ; x++, dbuf+=4 ) *(DWORD*)dbuf = *(DWORD*)dbuf&0x01010101;
			for( x=0 ; x<dw3 ; x++, dbuf++ )  *dbuf = *dbuf&0x01;
		}
	}
	return TRUE;
}
//hԂʃrbg
BOOL PDW_DrawPaint_LOW( PIECE_VRAM *dest, int dx, int dy, int dw, int dh, BYTE color )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;
	int		dw2 = dw/4;
	int		dw3 = dw%4;
	
	if( 0x01&color ){
		for( y=0 ; y<dh ; y++, dbuf+=dddx ){
			for( x=0 ; x<dw2 ; x++, dbuf+=4 ) *(DWORD*)dbuf = *(DWORD*)dbuf|0x01010101;
			for( x=0 ; x<dw3 ; x++, dbuf++ )  *dbuf = *dbuf|0x01;
		}
	}else{
		for( y=0 ; y<dh ; y++, dbuf+=dddx ){
			for( x=0 ; x<dw2 ; x++, dbuf+=4 ) *(DWORD*)dbuf = *(DWORD*)dbuf&0x02020202;
			for( x=0 ; x<dw3 ; x++, dbuf++ )  *dbuf = *dbuf&0x02;
		}
	}
	return TRUE;
}
//hԂ]
BOOL PDW_DrawPaint_NOT( PIECE_VRAM *dest, int dx, int dy, int dw, int dh )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;

	for( y=0 ; y<dh ; y++, dbuf+=dddx ){
		for( x=0 ; x<dw ; x++, dbuf++ ){ *dbuf = (~*dbuf)&0x03; }
	}
	return TRUE;
}
//hԂ
BOOL PDW_DrawPaint_HALF( PIECE_VRAM *dest, int dx, int dy, int dw, int dh )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;

	for( y=0 ; y<dh ; y++, dbuf+=dddx ){
		for( x=0 ; x<dw ; x++, dbuf++ ){ *dbuf = (*dbuf>>1)+2; }
	}
	return TRUE;
}
//hԂ
BOOL PDW_DrawPaint_LIGHT( PIECE_VRAM *dest, int dx, int dy, int dw, int dh )
{
	int		x,y;
	BYTE	*dbuf = dest->buf + dy*dest->w + dx;
	int		dddx = dest->w-dw;

	for( y=0 ; y<dh ; y++, dbuf+=dddx ){
		for( x=0 ; x<dw ; x++, dbuf++ ){ *dbuf = (*dbuf>>1); }
	}
	return TRUE;
}
//hԂ[`[g
BOOL PDW_DrawPaint( DRAW_OBJECT2 dobj )
{
	short	dx=dobj.dx, dy=dobj.dy;
	short	dw=dobj.dw, dh=dobj.dh;
	//NbsO
	if( !ClipRectDest( &dx, &dy, BackBuf.w, BackBuf.h, &dw, &dh, NULL ) )
		return FALSE;

	switch(dobj.param){	//]^Cv
//		case DRW_NOMAL : pceLCDPaint( (BYTE)limit(dobj.color1,0,3), dobj.dx, dobj.dy, dobj.dw, dobj.dh );	break;	// x^]
		case DRW_NOMAL : PDW_DrawPaint_NOMAL( &BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,3) );	break;	// x^]
		case DRW_ADD   : PDW_DrawPaint_ADD(   &BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,3) );	break;	// OaZ ]
		case DRW_SUB   : PDW_DrawPaint_SUB(   &BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,3) );	break;	// OaZ ]
		case DRW_HIGH  : PDW_DrawPaint_HIGH(  &BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,3) );	break;	// HIGH ]
		case DRW_LOW   : PDW_DrawPaint_LOW(   &BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,3) );	break;	// LOW ]
		case DRW_NOT   : PDW_DrawPaint_NOT(   &BackBuf, dx, dy, dw, dh );	break;	// NOT ](rbg]lK)
		case DRW_HALF  : PDW_DrawPaint_HALF(  &BackBuf, dx, dy, dw, dh );	break;	// 
		case DRW_LIGHT : PDW_DrawPaint_LIGHT( &BackBuf, dx, dy, dw, dh );	break;	// 
//		case DRW_BRIGHT: PDW_DrawPaint_BRIGHT(&BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,7) );break;	// x^]
//		case DRW_MESH  : PDW_DrawPaint_MESH(  &BackBuf, dx, dy, dw, dh, (BYTE)limit(dobj.color1,0,3) );break;	// x^]
	}
	return TRUE;
}


static short	Font8Sx=0;
static short	Font8Sy=0;

static short	Font6Sx=0;
static short	Font6Sy=0;

static short	Font4Sx=0;
static short	Font4Sy=0;

//tHg
static short	Font0Sx=0;
static short	Font0Sy=0;

BOOL PDW_SetFontPosition( int fsize, int sx, int sy )
{
	switch(fsize){
		case 8:	Font8Sx = sx;	Font8Sy = sy;	break;
		case 6:	Font6Sx = sx;	Font6Sy = sy;	break;
		case 4:	Font4Sx = sx;	Font4Sy = sy;	break;
		case 0:	Font0Sx = sx;	Font0Sy = sy;	break;
	}
	return TRUE;
}

BOOL PDW_DrawText( int dx, int dy, int sx, int sy, int fw, int fh, int param )
{
	DRAW_OBJECT	image;
	
	pceLCDSetObject( &image, &Vram1B, dx, dy, sx, sy, fw, fh, param );
	pceLCDDrawObject( image );
	
	return TRUE;
}

BOOL PDW_TextOutStr_10( unsigned char *str, int dx, int dy, int fx, int fy, int pw, int ph, int cl1, int cl2 )
{
	int	px=0,py=0;
	int	kinnsoku=0;

#ifndef _WIN32
	pceFontSetTxColor( cl1 );
	if(cl2<4)	pceFontSetBkColor( cl2 );
	else		pceFontSetBkColor( -1 );//
#endif

	while(*str){
		if( *str=='\n' ){
			px=0;
			py+=fy;
			str++;
			continue;
		}
		if(pw && pw<px+fx){
			if( (strncmp( str, "B", 2 ) && strncmp( str, "A", 2 ) && strncmp( str, "H", 2 ) && strncmp( str, "I", 2 ) &&
				strncmp( str, "j", 2 ) && strncmp( str, "v", 2 ) && strncmp( str, "x", 2 )) || kinnsoku )
			{
				kinnsoku=0;
				px=0;
				py+=fy;
			}else{
				kinnsoku=1;
			}
		}
		if( (0x81 <= *str && *str <= 0x9f) || (0xe0 <= *str && *str <= 0xea) || (0xf0==*str) ){//Sp
#ifdef _WIN32
			P2W_TextOutStr( &BackBuf, dx+px, dy+py, (unsigned char*)str, 2, (BYTE)cl1 );
#else
			pceFontPut( dx+px, dy+py, (*str<<8) | *(str+1) );
#endif
			px+=fx;
			str+=2;
			continue;
		}else if( (0x21 <= *str && *str <= 0x7e) || (0xa1 <= *str && *str <= 0xdf) ){//p
#ifdef _WIN32
			P2W_TextOutStr( &BackBuf, dx+px, dy+py, (unsigned char*)str, 1, (BYTE)cl1 );
#else
			pceFontPut( dx+px, dy+py, (unsigned short)*str );
#endif
			px+=fx/2;
			str++;
			continue;
		}
		px+=fx/2;
		str++;

	}
	return TRUE;
}
//
BOOL PDW_TextOutStr_8( unsigned char *src, int dx, int dy, int fx, int fy, int pw, int ph, int cl1, int cl2 )
{
	int	code=0;
	int	px=0,py=0;
	while(*src){
		switch(*src){
			case 0x81:
				switch(*(src+1)){
					default:	break;
					case 0x40:
						if(fx)	px+=fx;
						else	px+=8;
						break;

					//[
					case 0x5B:
						code = '-'-0x20;
						PDW_DrawText( dx+px, dy+py, Font8Sx+code%16*8, Font8Sy+code/16*8+12*8, 8, 8, DRW_CLR(cl1,cl2) );
						px+=fx;
						break;

					//
					case 0xa8: case 0xa9: case 0xaa: case 0xab:
						code = *(src+1)-0xa8;
						PDW_DrawText( dx+px, dy+py, Font8Sx+code%16*8+12*8, Font8Sy+11*8, 8, 8, DRW_CLR(cl1,cl2) );
						if(fx)	px+=fx;
						else	px+=8;
						break;
				}
				src+=2;
				break;
			case 0x82://Ђ炪
				if( 0x9f<=*(src+1) && *(src+1)<=0xf1 ){
					code = *(src+1)-0x9f;
					PDW_DrawText( dx+px, dy+py, Font8Sx+code%16*8, Font8Sy+code/16*8, 8, 8, DRW_CLR(cl1,cl2) );
					px+=fx;
				}
				src+=2;
				break;
			case 0x83://J^Ji
				if( 0x40<=*(src+1) && *(src+1)<=0x96 ){
					if( *(src+1)<=0x7e )code = *(src+1)-0x40;
					if( 0x80<=*(src+1) )code = *(src+1)-0x40-1;
					PDW_DrawText( dx+px, dy+py, Font8Sx+code%16*8, Font8Sy+code/16*8+6*8, 8, 8, DRW_CLR(cl1,cl2) );
					px+=fx;
				}
				src+=2;
				break;
			case '\n':	px=0;	py+=fy;	src++;	break;
			case ' ':	px+=fx;			src++;	break;
			default://p
				if( '!'<=*src && *src<='z' ){
					if( 'a'<=*src && *src<='z' ) code = *src-0x40;
					else						 code = *src-0x20;
					PDW_DrawText( dx+px, dy+py, Font8Sx+code%16*8, Font8Sy+code/16*8+12*8, 8, 8, DRW_CLR(cl1,cl2) );
					px+=fx;
				}
				src++;
				break;
		}
		if(pw && pw<px+fx){
			px=0;
			py+=fy;
		}
	}
	return TRUE;
}
//
BOOL PDW_TextOutStr_6( unsigned char *src, int dx, int dy, int fx, int fy, int pw, int ph, int cl1, int cl2 )
{
	int	code=10;
	int	px=0,py=0;

	while(*src){
		switch(*src){
			default:
				if( '!'<=*src && *src<='z' ){
					if( 'a'<=*src && *src<='z' ) code = *src-'a'+'A'-'!';
					else						 code = *src-'!';
					PDW_DrawText( dx+px, dy+py, Font6Sx+code%21*6, Font6Sy+code/21*6, 6, 6, DRW_CLR(cl1,cl2) );
					px+=fx;
				}
				src++;
				break;
			case '\n':	px=0;	py+=fy;	src++;	break;
			case ' ':	px+=fx;			src++;	break;
			case 0x81:
				if(*src==0x40){
					px+=fx;
					src+=2;
				}else{
					src++;
				}
				break;
		}
		if(pw && pw<px+fx){
			px=0;
			py+=fy;
		}
	}
	return TRUE;
}
//
BOOL PDW_TextOutStr_4( unsigned char *src, int dx, int dy, int fx, int fy, int pw, int ph, int cl1, int cl2 )
{
	int	code;
	int	px=0,py=0;
	while(*src){
		switch(*src){
			default:
				if( '!'<=*src && *src<='z' ){
					if( 'a'<=*src && *src<='z' ) code = *src-'a'+'A'-'!';
					else						 code = *src-'!';
					PDW_DrawText( dx+px, dy+py, Font4Sx+code%32*4, Font4Sy+code/32*6, 4, 6, DRW_CLR(cl1,cl2) );
					px+=fx;
				}
				src++;
				break;
			case '\n':	px=0;	py+=fy;	src++;	break;
			case ' ':	px+=fx;			src++;	break;
			case 0x81://
				switch(*(src+1)){
					default:	break;
					case 0x40:
						if(fx)	px+=fx;
						else	px+=4;
						break;

					//
					case 0xa8: case 0xa9:
						code = *(src+1)-0xa8;
						PDW_DrawText( dx+px, dy+py, Font4Sx+code*4+120, Font4Sy+6, 4, 6, DRW_CLR(cl1,cl2) );
						if(fx)	px+=fx;
						else	px+=4;
						break;
					case 0xaa: case 0xab:
						code = *(src+1)-0xaa;
						PDW_DrawText( dx+px, dy+py, Font4Sx+code*8+104, Font4Sy+6, 6, 6, DRW_CLR(cl1,cl2) );
						if(fx)	px+=fx;
						else	px+=6;
						break;
				}
				src+=2;
				break;


				break;
		}
		if(pw && pw<px+fx){
			px=0;
			py+=fy;
		}
	}
	return TRUE;
}
//
BOOL PDW_TextOutStr_SP( unsigned char *src, int dx, int dy, int fx, int fy, int pw, int ph, int digit_mode )
{
	int	code;
	int	px=0,py=0;
	DRAW_OBJECT	image;

	while(*src){
		switch(*src){
			default:
				if( '!'<=*src && *src<='_' ){
					if( 'a'<=*src && *src<='z' ) code = *src-0x40;//
					else						 code = *src-0x20;

					if( digit_mode && ('0'<=*src && *src<='9') ){
						code = *src-0x20+3*16+4;
					}

					pceLCDSetObject( &image, &Vram2BM, dx+px, dy+py, Font0Sx+code%16*8, Font0Sy+code/16*8, 8, 8, DRW_NOMAL );
					pceLCDDrawObject( image );

					if(fx==0){
						if(!digit_mode && ('0'<=*src && *src<='9'))	px+=4;
						else										px+=6;
					}else{
						px+=fx;
					}
				}
				src++;
				break;
			case '\n':
				px=0;
				if(fy)	py+=fy;
				else	py+=6;
				src++;
				break;
			case ' ':
				if(fx)	px+=fx;
				else	px+=4;
				src++;
				break;
			case 0x81:
				switch(*(src+1)){
					default:	src++;	break;
					case 0x40:
						if(fx)	px+=fx;
						else	px+=6;
						src+=2;
						break;

					//
					case 0xa8: case 0xa9: case 0xaa: case 0xab:
						code = 0x40 + *(src+1)-0xa8;
						pceLCDSetObject( &image, &Vram2BM, dx+px, dy+py, Font0Sx+code%16*8, Font0Sy+code/16*8, 8, 8, DRW_NOMAL );
						pceLCDDrawObject( image );

						if(fx)	px+=fx;
						else	px+=6;
						src+=2;
						break;
				}
				break;
		}
		if(pw && pw<px+6){
			px=0;
			if(fy)	py+=fy;
			else	py+=6;
		}
	}
	return TRUE;
}
//
BOOL PDW_TextOutStr( DRAW_OBJECT2 dobj )
{
	BOOL	ret=FALSE;
	unsigned char	buf[16];

	if(dobj.src){
		switch(dobj.sx){
			default:
			case 10: ret=PDW_TextOutStr_10( (unsigned char*)dobj.src, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case 8:	 ret=PDW_TextOutStr_8(  (unsigned char*)dobj.src, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case 6:	 ret=PDW_TextOutStr_6(  (unsigned char*)dobj.src, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case 4:	 ret=PDW_TextOutStr_4(  (unsigned char*)dobj.src, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case -1: 
			case 0:	 ret=PDW_TextOutStr_SP( (unsigned char*)dobj.src, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.sx );	break;
		}
	}else{
		{//`
			int keta = (dobj.dh&0x3f);
			int keta2=0,work, fast=0;
			int	flag = dobj.dh;
			work=dobj.sy;
			while(work){ keta2++; work=work/10; }
			if(keta2<=0) keta2 = 1;

			if( (flag&DGT_RIGHT) | (flag&DGT_ZERO) ){//[tO,El
				if(keta2<keta) keta2 = keta;
				work=dobj.sy;
				buf[keta2] = '\0';
				while(keta2){
					keta2--;
					if(dobj.dh&DGT_ZERO || work || fast==0){
						buf[keta2] = '0'+work%10;
						work=work/10;
						fast=1;
					}else{
						buf[keta2] = ' ';
					}
				}
			}else{//l
				if(keta<keta2) keta = keta2;
				work=dobj.sy;
				buf[keta] = '\0';
				while(keta){
					keta--;
					if(keta<keta2){
						buf[keta] = '0'+work%10;
						work=work/10;
					}else{
						buf[keta] = ' ';
					}
				}
			}
		}
		switch(dobj.sx){
			default:
			case 10: ret=PDW_TextOutStr_10( buf, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case 8:	 ret=PDW_TextOutStr_8(  buf, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case 6:	 ret=PDW_TextOutStr_6(  buf, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case 4:	 ret=PDW_TextOutStr_4(  buf, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.color1, dobj.color2 );	break;
			case -1:
			case 0:	 ret=PDW_TextOutStr_SP( buf, dobj.dx, dobj.dy, dobj.sw, dobj.sh, dobj.dw, dobj.dh, dobj.sx );	break;
		}
	}
	return ret;
}

//+=+=  `o^VXe +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

static LIST_DOBJ	StartObj;
static LIST_DOBJ	*ListObj=NULL;		//36*256 = 9,216BYTE
static short		ListSize=0;
//	static LIST_DOBJ	ListObj[256];	//36*256 = 9,216BYTE

BOOL PDW_InitDrawGraph( BYTE *list, int list_size )
{
	if(list){
		ListObj  = (LIST_DOBJ *)list;
		ListSize = list_size;
		return TRUE;
	}else{
		return FALSE;
	}
}

//
LIST_DOBJ *GetListObject( void )
{
	int	i;
	for(i=0;i<ListSize;i++){
		if(ListObj[i].front==NULL){
			memset2( &ListObj[i], 0 , sizeof(LIST_DOBJ) );
			return &ListObj[i];
		}
	}
	return NULL;
}

//
LIST_DOBJ *CreateDrawObject( BYTE layer )
{
	LIST_DOBJ	*lobj = StartObj.next, *work_obj;
	LIST_DOBJ	*new_lobj = GetListObject();
	LIST_DOBJ	*front_obj = &StartObj;

	if(!new_lobj) return NULL;//Xg؂

	while(lobj){
		if(lobj->dobj2.layer>=layer){
			work_obj = lobj->front;
			work_obj->next = new_lobj;

			lobj->front = new_lobj;
			new_lobj->front = work_obj;
			new_lobj->next  = lobj;

			return new_lobj;
		}
		front_obj = lobj;
		lobj = lobj->next;
	}
	front_obj->next = new_lobj;
	new_lobj->front = front_obj;
	return new_lobj;
}
//
BOOL ReleaseDrawObject( LIST_DOBJ *lobj )
{
	LIST_DOBJ *fobj, *nobj;
	if( !lobj ) return FALSE;

	fobj = lobj->front;
	nobj = lobj->next;

	memset2( lobj, 0, sizeof(LIST_DOBJ) );

	if(fobj) fobj->next  = nobj;
	if(nobj) nobj->front = fobj;
	return TRUE;
}
//
BOOL ChangeDrawObject( LIST_DOBJ *taget_obj )
{
	LIST_DOBJ	*lobj = StartObj.next, *work_obj, *front_obj = &StartObj;

//Xg폜
	if(taget_obj->front) ((LIST_DOBJ *)taget_obj->front)->next = taget_obj->next;
	if(taget_obj->next ) ((LIST_DOBJ *)taget_obj->next)->front = taget_obj->front;

	while( lobj ){
		if(lobj->dobj2.layer>=taget_obj->dobj2.layer){
			work_obj = lobj->front;
			work_obj->next = taget_obj;

			lobj->front = taget_obj;
			taget_obj->front = work_obj;
			taget_obj->next  = lobj;

			return TRUE;
		}
		front_obj = lobj;
		lobj = lobj->next;
	}
	work_obj = front_obj->next;
	front_obj->next = taget_obj;
	taget_obj->next = work_obj;
	taget_obj->front = front_obj;
	return TRUE;
}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
BOOL PDW_SetDrawText( DRAW_OBJECT2 **dobj, char *src, int dx, int dy, int fsize, int color, int disp, int layer )
{
	if(dobj==NULL) return FALSE;
	if(*dobj) PDW_ResetDraw( dobj );
	*dobj = (DRAW_OBJECT2 *)CreateDrawObject( (BYTE)layer );
	if( *dobj==NULL ) return FALSE;

	(*dobj)->dx   = dx;
	(*dobj)->dy   = dy;
	(*dobj)->dw   = 0;
	(*dobj)->dh   = 0;

	if(src)	(*dobj)->src  = (PIECE_BMP *)src;	//|C^
	else	(*dobj)->src  = (PIECE_BMP *)"";

	if(fsize==-1 || fsize==0){
		(*dobj)->sx   = fsize;	//tHgTCYiPOFBIOStHg WFQ[tHg UFp̂݁j
		(*dobj)->sy   = 0;
		(*dobj)->sw   = 0;
		(*dobj)->sh   = 0;
	}else{
		(*dobj)->sx   = fsize;	//tHgTCYiPOFBIOStHg WFQ[tHg UFp̂݁j
		(*dobj)->sy   = 0;
		(*dobj)->sw   = fsize;
		(*dobj)->sh   = fsize;
	}

	(*dobj)->layer = layer;
	(*dobj)->disp  = disp;
	(*dobj)->type  = TYPE_TXT;
	(*dobj)->param = DRW_NOMAL;

	(*dobj)->rev_x  = FALSE;
	(*dobj)->rev_y  = FALSE;
	(*dobj)->color1 = color;
	(*dobj)->color2 = COLOR_MASK;

	(*dobj)->clip.left   = 0;
	(*dobj)->clip.top    = 0;
	(*dobj)->clip.right  = SCREEN_W;
	(*dobj)->clip.bottom = SCREEN_H;

	return TRUE;
}
BOOL PDW_SetDrawDigit( DRAW_OBJECT2 **dobj, int digit, int dg_param, int dx, int dy, int fsize, int color, int disp, int layer )
{
	if(dobj==NULL) return FALSE;
	if(*dobj) PDW_ResetDraw( dobj );
	*dobj = (DRAW_OBJECT2 *)CreateDrawObject( (BYTE)layer );
	if( *dobj==NULL ) return FALSE;

	(*dobj)->dx   = dx;
	(*dobj)->dy   = dy;
	(*dobj)->dw   = 0;
	(*dobj)->dh   = dg_param;

	(*dobj)->src  = NULL;	//|C^

	if(fsize==-1 || fsize==0){
		(*dobj)->sx   = fsize;	//tHgTCYiPOFBIOStHg WFQ[tHg UFp̂݁j
		(*dobj)->sy   = digit;
		(*dobj)->sw   = 0;
		(*dobj)->sh   = 0;
	}else{
		(*dobj)->sx   = fsize;	//tHgTCYiPOFBIOStHg WFQ[tHg UFp̂݁j
		(*dobj)->sy   = digit;
		(*dobj)->sw   = fsize;
		(*dobj)->sh   = fsize;
	}

	(*dobj)->layer = layer;
	(*dobj)->disp  = disp;
	(*dobj)->type  = TYPE_TXT;
	(*dobj)->param = DRW_NOMAL;

	(*dobj)->rev_x  = FALSE;
	(*dobj)->rev_y  = FALSE;
	(*dobj)->color1 = color;
	(*dobj)->color2 = COLOR_MASK;

	(*dobj)->clip.left   = 0;
	(*dobj)->clip.top    = 0;
	(*dobj)->clip.right  = SCREEN_W;
	(*dobj)->clip.bottom = SCREEN_H;

	return TRUE;
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
BOOL PDW_SetDrawPaint( DRAW_OBJECT2 **dobj, int dx, int dy, int w, int h, int color, int disp, int layer )
{
	if(dobj==NULL) return FALSE;
	if(*dobj) PDW_ResetDraw( dobj );
	*dobj = (DRAW_OBJECT2 *)CreateDrawObject( (BYTE)layer );
	if( *dobj==NULL ) return FALSE;

	(*dobj)->dx   = dx;
	(*dobj)->dy   = dy;
	(*dobj)->dw   = w;
	(*dobj)->dh   = h;

	(*dobj)->src  = NULL;
	(*dobj)->sx   = 0;
	(*dobj)->sy   = 0;
	(*dobj)->sw   = 0;
	(*dobj)->sh   = 0;

	(*dobj)->layer = layer;
	(*dobj)->disp  = disp;
	(*dobj)->type  = TYPE_PNT;
	(*dobj)->param = DRW_NOMAL;

	(*dobj)->rev_x  = FALSE;
	(*dobj)->rev_y  = FALSE;
	(*dobj)->color1 = color;
	(*dobj)->color2 = COLOR_MASK;

	(*dobj)->clip.left   = 0;
	(*dobj)->clip.top    = 0;
	(*dobj)->clip.right  = SCREEN_W;
	(*dobj)->clip.bottom = SCREEN_H;

	return TRUE;
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//DRAW_OBJECT2 *PDW_SetDraw( int dx, int dy, int w, int h, int sx, int sy, int vram, int disp, int layer )
BOOL PDW_SetDraw( DRAW_OBJECT2 **dobj, int dx, int dy, int w, int h, int sx, int sy, int vram, int disp, int layer )
{
	if(dobj==NULL) return FALSE;
	if(*dobj) PDW_ResetDraw( dobj );
	*dobj = (DRAW_OBJECT2 *)CreateDrawObject( (BYTE)layer );
	if( *dobj==NULL ) return FALSE;

	(*dobj)->dx   = dx;
	(*dobj)->dy   = dy;
	(*dobj)->dw   = w;
	(*dobj)->dh   = h;

	switch(vram){
		case VRAM_1B:	(*dobj)->src  = &Vram1B;	break;
		case VRAM_2B:	(*dobj)->src  = &Vram2B;	break;
		case VRAM_2BM:	(*dobj)->src  = &Vram2BM;	break;
	}
		
	(*dobj)->sx   = sx;
	(*dobj)->sy   = sy;
	(*dobj)->sw   = w;
	(*dobj)->sh   = h;

	(*dobj)->layer = layer;
	(*dobj)->disp  = disp;
	(*dobj)->type  = TYPE_BMP;
	(*dobj)->param = DRW_NOMAL;

	(*dobj)->rev_x  = FALSE;
	(*dobj)->rev_y  = FALSE;
	(*dobj)->color1 = 0;
	(*dobj)->color2 = COLOR_MASK;

	(*dobj)->clip.left   = 0;
	(*dobj)->clip.top    = 0;
	(*dobj)->clip.right  = SCREEN_W;
	(*dobj)->clip.bottom = SCREEN_H;

	return TRUE;
}
//
BOOL PDW_ResetDraw( DRAW_OBJECT2 **dobj )
{
	BOOL	ret;
	if( dobj==NULL || *dobj==NULL ) return FALSE;
	ret = ReleaseDrawObject( (LIST_DOBJ *)*dobj );
	*dobj = NULL;
	return ret;
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
BOOL PDW_SetDrawLayer( DRAW_OBJECT2 *dobj, int layer )
{
	if( dobj==NULL ) return FALSE;

	if( dobj->layer!=(unsigned)layer ){
		dobj->layer = layer;
		ChangeDrawObject( (LIST_DOBJ*)dobj);
	}
	return TRUE;
}
//
BOOL PDW_SetDrawDisp( DRAW_OBJECT2 *dobj, int disp )
{
	if( dobj==NULL ) return FALSE;
	dobj->disp = disp;
	return TRUE;
}
//
BOOL PDW_SetDrawParam( DRAW_OBJECT2 *dobj, int param )
{
	if( dobj==NULL ) return FALSE;
	dobj->param = param;
	return TRUE;
}
//
BOOL PDW_SetDrawRev( DRAW_OBJECT2 *dobj, int rev_x, int rev_y )
{
	if( dobj==NULL ) return FALSE;
	dobj->rev_x  = rev_x;
	dobj->rev_y  = rev_y;
	return TRUE;
}
//
BOOL PDW_SetDrawColor( DRAW_OBJECT2 *dobj, int color1, int color2 )
{
	if( dobj==NULL ) return FALSE;
	dobj->color1 = color1;
	dobj->color2 = color2;
	return TRUE;
}
//
BOOL PDW_SetDrawPalette( DRAW_OBJECT2 *dobj, BYTE pal0, BYTE pal1, BYTE pal2, BYTE pal3 )
{
	if( dobj==NULL ) return FALSE;
	dobj->color1 = (pal0<<6) | (pal1<<4) | (pal2<<2) | pal3;
	return TRUE;
}
//
BOOL PDW_SetDrawTextStr( DRAW_OBJECT2 *dobj, char *src )
{
	if( dobj==NULL ) return FALSE;
	if(src)	dobj->src = (PIECE_BMP *)src;	//|C^
	else	dobj->src = (PIECE_BMP *)"";
	return TRUE;
}
//
BOOL PDW_SetDrawTextPitch( DRAW_OBJECT2 *dobj, char pw, int ph )
{
	if( dobj==NULL ) return FALSE;
	dobj->dw = pw;
	dobj->dh = ph;
	return TRUE;
}
//
BOOL PDW_SetDrawDigitNum( DRAW_OBJECT2 *dobj, int digit )
{
	if( dobj==NULL ) return FALSE;
	dobj->sy   = digit;
	return TRUE;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
BOOL PDW_SetDrawPosEx( DRAW_OBJECT2 *dobj, int dx, int dy, int dw, int dh, int sx, int sy, int sw, int sh )
{
	if( dobj==NULL ) return FALSE;
	dobj->dx = limit(dx,-256,255);
	dobj->dy = limit(dy,-256,255);
	dobj->dw = limit(dw,-256,255);
	dobj->dh = limit(dh,-256,255);
	
	dobj->sx = limit(sx,-256,255);
	dobj->sy = limit(sy,-256,255);
	dobj->sw = limit(sw,-256,255);
	dobj->sh = limit(sh,-256,255);

	return TRUE;
}
//
BOOL PDW_SetDrawPos( DRAW_OBJECT2 *dobj, int dx, int dy, int w, int h, int sx, int sy )
{
	if( dobj==NULL ) return FALSE;
	dobj->dx = limit(dx,-256,255);
	dobj->dy = limit(dy,-256,255);
	dobj->sw = dobj->dw = limit(w,-256,255);
	dobj->sh = dobj->dh = limit(h,-256,255);
	dobj->sx = limit(sx,-256,255);
	dobj->sy = limit(sy,-256,255);
	return TRUE;
}
//
BOOL PDW_SetDrawDestRect( DRAW_OBJECT2 *dobj, int dx, int dy, int w, int h )
{
	if( dobj==NULL ) return FALSE;
	dobj->dx = limit(dx,-256,255);
	dobj->dy = limit(dy,-256,255);
	dobj->dw = limit(w,-256,255);
	dobj->dh = limit(h,-256,255);
	return TRUE;
}
//
BOOL PDW_SetDrawSrcRect( DRAW_OBJECT2 *dobj, int sx, int sy, int sw, int sh )
{
	if( dobj==NULL ) return FALSE;
	dobj->sx = limit(sx,-256,255);
	dobj->sy = limit(sy,-256,255);
	dobj->sw = limit(sw,-256,255);
	dobj->sh = limit(sh,-256,255);
	return TRUE;
}
//
BOOL PDW_SetDrawMove( DRAW_OBJECT2 *dobj, int dx, int dy )
{
	if( dobj==NULL ) return FALSE;
	dobj->dx = limit(dx,-256,255);
	dobj->dy = limit(dy,-256,255);
	return TRUE;
}
//
BOOL PDW_SetDrawSrcMove( DRAW_OBJECT2 *dobj, int sx, int sy )
{
	if( dobj==NULL ) return FALSE;
	dobj->sx = sx;
	dobj->sy = sy;
	return TRUE;
}
//
BOOL PDW_SetDrawDigitPich( DRAW_OBJECT2 *dobj, int pw, int ph )
{
	if( dobj==NULL ) return FALSE;
	dobj->sw = pw;
	dobj->sh = ph;
	return TRUE;
}
//
BOOL PDW_SetDrawClip( DRAW_OBJECT2 *dobj, int cl, int ct, int cr, int cb )
{
	if( dobj==NULL ) return FALSE;
	dobj->clip.left   = cl;
	dobj->clip.top    = ct;
	dobj->clip.right  = cr;
	dobj->clip.bottom = cb;
	return TRUE;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//////////////////
int PDW_GetDrawLayer( DRAW_OBJECT2 *dobj )
{
	if( dobj==NULL ) return FALSE;
	return dobj->layer;
}
//
int PDW_GetDrawDisp( DRAW_OBJECT2 *dobj )
{
	if( dobj==NULL ) return FALSE;
	return dobj->disp;
}
//
int PDW_GetDrawParam( DRAW_OBJECT2 *dobj )
{
	if( dobj==NULL ) return FALSE;
	return dobj->param;
}
//
BOOL PDW_GetDrawRev( DRAW_OBJECT2 *dobj, int *rev_x, int *rev_y )
{
	if( dobj==NULL ) return FALSE;
	*rev_x = dobj->rev_x;
	*rev_y = dobj->rev_y;
	return TRUE;
}
//
BOOL PDW_GetDrawColor( DRAW_OBJECT2 *dobj, int *color1, int *color2 )
{
	if( dobj==NULL ) return FALSE;
	*color1 = dobj->color1;
	*color2 = dobj->color2;
	return TRUE;
}
//
char *PDW_GetDrawTextStr( DRAW_OBJECT2 *dobj )
{
	if( dobj==NULL ) return FALSE;
	return (char *)dobj->src;
}
//
int PDW_GetDrawDigitNum( DRAW_OBJECT2 *dobj )
{
	if( dobj==NULL ) return FALSE;
	return dobj->sy;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

BOOL PDW_GetDrawPos( DRAW_OBJECT2 *dobj, int *dx, int *dy )
{
	if( dobj==NULL ) return FALSE;
	*dx = dobj->dx;
	*dy = dobj->dy;
	return TRUE;
}
//
BOOL PDW_GetDrawDestRect( DRAW_OBJECT2 *dobj, int *dx, int *dy, int *dw, int *dh )
{
	if( dobj==NULL ) return FALSE;
	*dx = dobj->dx;
	*dy = dobj->dy;
	*dw = dobj->dw;
	*dh = dobj->dh;
	return TRUE;
}
//
BOOL PDW_GetDrawSrcRect( DRAW_OBJECT2 *dobj, int *sx, int *sy, int *sw, int *sh )
{
	if( dobj==NULL ) return FALSE;
	*sx = dobj->sx;
	*sy = dobj->sy;
	*sw = dobj->sw;
	*sh = dobj->sh;
	return TRUE;
}
//
BOOL PDW_GetDrawDigitPich( DRAW_OBJECT2 *dobj, int *pw, int *ph )
{
	if( dobj==NULL ) return FALSE;
	*pw = dobj->sw;
	*ph = dobj->sh;
	return TRUE;
}
//
RECTP *PDW_GetDrawClip( DRAW_OBJECT2 *dobj )
{
	if( dobj==NULL ) return FALSE;
	return &dobj->clip;
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


void PDW_DrawGraph( int debug, int sx, int sy )
{
	LIST_DOBJ	*lobj = StartObj.next;
	DRAW_OBJECT2 dobj;
	dobj.dx = 0;
	dobj.dy = 0;
	dobj.dw = SCREEN_W;
	dobj.dh = SCREEN_H;
	dobj.sx = sx;
	dobj.sy = sy;
	dobj.sw = SCREEN_W;
	dobj.sh = SCREEN_H;
	
	dobj.layer = 255;	//32 ]
	dobj.disp  = TRUE;
	dobj.type  = 0;		//31 `^Cv
	dobj.param = DRW_NOMAL;

	dobj.rev_x	= 0;	//  ]tO
	dobj.rev_y	= 0;	// c]tO
	dobj.color1	= 0;	// 
	dobj.color2	= 3;	//(128) ]p[^

	dobj.clip.top    = 0;
	dobj.clip.left   = 0;
	dobj.clip.bottom = SCREEN_H;
	dobj.clip.right  = SCREEN_W;

	switch(debug){
		case 0:
			while(lobj){
				if(lobj->dobj2.disp){
					switch(lobj->dobj2.type){
						case TYPE_BMP:	PDW_DrawBmpEx( lobj->dobj2 );	break;	// BMP`
						case TYPE_PNT:	PDW_DrawPaint( lobj->dobj2 );	break;	// hԂ
						case TYPE_LIN:		break;	// C`
						case TYPE_PIX:		break;	// sNZ`
						case TYPE_TXT:	PDW_TextOutStr( lobj->dobj2 );	break;	// eLXg`
					}
				}
				lobj = lobj->next;
			}
			break;
		case 1:	//1B VRAM
			dobj.src = &Vram1B;
			PDW_DrawBmp( dobj );
			break;
		case 2:	//2B VRAM
			dobj.src = &Vram2B;
			PDW_DrawBmp( dobj );
			break;
		case 3:	//2B MASKtVRAM
			{
				int		x, y, w = BackBuf.w/4;
				DWORD	*buf = (DWORD*)BackBuf.buf;

				for(y=0;y<BackBuf.h;y++){
					switch(y/22){
						case 0:	for(x=0;x<w;x++,buf++) *buf = 0x00000000;	break;
						case 1:	for(x=0;x<w;x++,buf++) *buf = 0x01010101;	break;
						case 2:	for(x=0;x<w;x++,buf++) *buf = 0x02020202;	break;
						case 3:	for(x=0;x<w;x++,buf++) *buf = 0x03030303;	break;
					}
				}
			}
			
			dobj.src = &Vram2BM;
			PDW_DrawBmp( dobj );
			break;
	}
}


//
BOOL PDW_VramFlash( int color )
{
	return PDW_DrawPaint_NOMAL( &BackBuf, 0, 0, 128, 88, (BYTE)limit(color,0,3) );
}

//
static LDC_Bright[4]={0,85,170,255};

BOOL PDW_SetLDC_Color( int bright1, int bright2, int bright3, int bright4 )
{
	LDC_Bright[0] = bright1;
	LDC_Bright[1] = bright2;
	LDC_Bright[2] = bright3;
	LDC_Bright[3] = bright4;
//	P2W_SetLDC_Color( bright1, bright2, bright3, bright4 );
	return TRUE;
}

BOOL PDW_SetFade( int fade )
{
	int	br[4],i;
	if(fade<=128){
		for(i=0;i<4;i++)	br[i] = LDC_Bright[i]*fade/128;
	}else{
		for(i=0;i<4;i++)	br[i] = LDC_Bright[i] + (255-LDC_Bright[i])*(fade-128)/128;
	}
//	return P2W_SetLDC_Color( br[0], br[1], br[2], br[3] );
	return FALSE;
}

//-=-=-=-=-=-=-= VXeEChE -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#define WINDOW_MAX	6
typedef struct{
	short	x,y,w,h;
	short	disp;
	short	layer;
	char	*wname;

	DRAW_OBJECT2	*dobj[10];
}SYSTEM_WINDOW;
static SYSTEM_WINDOW	SysWin[WINDOW_MAX];//ɂS܂ŃEChE
static short	SysWinX = 0;
static short	SysWinY = 0;

//VXeEChE
BOOL PST_InitSystemWindow( int sx, int sy )
{
	int	i;

	SysWinX = sx;
	SysWinY = sy;

	for(i=0;i<WINDOW_MAX;i++)
		PST_ReleaseSystemWindow( i );

	if( !PDW_Load_2BM( "WD_000m.sld", sx, sy ) ) return FALSE;

	return TRUE;
}

//VXeEChEI
BOOL PST_TermSystemWindow( void )
{
	int	i;

	for(i=0;i<WINDOW_MAX;i++)
		PST_ReleaseSystemWindow( i );
	return TRUE;
}

//VXeEChE쐬
BOOL PST_CreateSystemWindow( int win_no, int x, int y, int w, int h, int layer, char *wname, int fsize )
{
	int		sy;

	if(w<8) w=8;
	if(h<8) h=8;
	if(SysWin[win_no].dobj[0]) PST_ReleaseSystemWindow(win_no);

	SysWin[win_no].x = x;
	SysWin[win_no].y = y;
	SysWin[win_no].w = w;
	SysWin[win_no].h = h;

	SysWin[win_no].disp  = TRUE;
	SysWin[win_no].layer = layer;
	SysWin[win_no].wname = wname;

	if(fsize)	sy = -fsize/2+1;
	else		sy = -2;

	if(wname){
		PDW_SetDrawText( &SysWin[win_no].dobj[9], wname, x+5, y+sy, fsize, 0x00, TRUE, layer+1 );
		PDW_SetDrawColor( SysWin[win_no].dobj[9], COLOR_BLACK, COLOR_WHITE );
	}else{
		PDW_ResetDraw( &SysWin[win_no].dobj[9] );
	}

	PDW_SetDraw( &SysWin[win_no].dobj[0], x,     y,       4,   4,  SysWinX+0, SysWinY+0, VRAM_2BM, TRUE, layer );
	if(wname && fsize!=0)	PDW_SetDraw( &SysWin[win_no].dobj[1], x+5,   y,     w-8,   4,  SysWinX+4, SysWinY+0, VRAM_2BM, TRUE, layer );
	else					PDW_SetDraw( &SysWin[win_no].dobj[1], x+4,   y,     w-8,   4,  SysWinX+4, SysWinY+0, VRAM_2BM, TRUE, layer );
	PDW_SetDraw( &SysWin[win_no].dobj[2], x+w-4, y,       4,   4,  SysWinX+8, SysWinY+0, VRAM_2BM, TRUE, layer );

	PDW_SetDraw( &SysWin[win_no].dobj[3], x,     y+4,     4, h-8,  SysWinX+0, SysWinY+4, VRAM_2BM, TRUE, layer );
//		PDW_SetDraw( &SysWin[win_no].dobj[4], x+4,   y+4,   w-8, h-8,  SysWinX+4, SysWinY+4, VRAM_2BM, TRUE, layer );
	PDW_SetDrawPaint( &SysWin[win_no].dobj[4], x+4,   y+4,   w-8, h-8,  COLOR_WHITE, TRUE, layer );
	PDW_SetDraw( &SysWin[win_no].dobj[5], x+w-4, y+4,     4, h-8,  SysWinX+8, SysWinY+4, VRAM_2BM, TRUE, layer );

	PDW_SetDraw( &SysWin[win_no].dobj[6], x,     y+h-4,   4,   4,  SysWinX+0, SysWinY+8, VRAM_2BM, TRUE, layer );
	PDW_SetDraw( &SysWin[win_no].dobj[7], x+4,   y+h-4, w-8,   4,  SysWinX+4, SysWinY+8, VRAM_2BM, TRUE, layer );
	PDW_SetDraw( &SysWin[win_no].dobj[8], x+w-4, y+h-4,   4,   4,  SysWinX+8, SysWinY+8, VRAM_2BM, TRUE, layer );


	PDW_SetDrawSrcRect( SysWin[win_no].dobj[1], SysWinX+4, SysWinY+0, 4, 4 );
	PDW_SetDrawSrcRect( SysWin[win_no].dobj[3], SysWinX+0, SysWinY+4, 4, 4 );
	PDW_SetDrawSrcRect( SysWin[win_no].dobj[4], SysWinX+4, SysWinY+4, 4, 4 );
	PDW_SetDrawSrcRect( SysWin[win_no].dobj[5], SysWinX+8, SysWinY+4, 4, 4 );
	PDW_SetDrawSrcRect( SysWin[win_no].dobj[7], SysWinX+4, SysWinY+8, 4, 4 );

	return TRUE;
}

//VXeEChEJ
BOOL PST_ReleaseSystemWindow( int win_no )
{
	int	i;
	
	for(i=0;i<10;i++)
		PDW_ResetDraw( &SysWin[win_no].dobj[i] );
	memset2( &SysWin[win_no], 0, sizeof(SYSTEM_WINDOW) );

	return TRUE;
}

BOOL PST_MoveSystemWindow( int win_no, int x, int y, int w, int h )
{
	if(w<8) w=8;
	if(h<8) h=8;
	SysWin[win_no].x = x;
	SysWin[win_no].y = y;
	SysWin[win_no].w = w;
	SysWin[win_no].h = h;

	PDW_SetDrawDestRect( SysWin[win_no].dobj[0], x,     y,       4, 4 );
	if(SysWin[win_no].wname)
		PDW_SetDrawDestRect( SysWin[win_no].dobj[1], x+5,   y,     w-8, 4 );
	else
		PDW_SetDrawDestRect( SysWin[win_no].dobj[1], x+4,   y,     w-8, 4 );

	PDW_SetDrawDestRect( SysWin[win_no].dobj[2], x+w-4, y,       4, 4 );

	PDW_SetDrawDestRect( SysWin[win_no].dobj[3], x,     y+4,     4, h-8 );
	PDW_SetDrawDestRect( SysWin[win_no].dobj[4], x+4,   y+4,   w-8, h-8 );
	PDW_SetDrawDestRect( SysWin[win_no].dobj[5], x+w-4, y+4,     4, h-8 );

	PDW_SetDrawDestRect( SysWin[win_no].dobj[6], x,     y+h-4,   4, 4 );
	PDW_SetDrawDestRect( SysWin[win_no].dobj[7], x+4,   y+h-4, w-8, 4 );
	PDW_SetDrawDestRect( SysWin[win_no].dobj[8], x+w-4, y+h-4,   4, 4 );

	PDW_SetDrawMove( SysWin[win_no].dobj[9], x+5, y-2 );

	return TRUE;
}

BOOL PST_DispSystemWindow( int win_no, int disp )
{
	SysWin[win_no].disp  = disp;

	PDW_SetDrawDisp( SysWin[win_no].dobj[0], disp );
	PDW_SetDrawDisp( SysWin[win_no].dobj[1], disp );
	PDW_SetDrawDisp( SysWin[win_no].dobj[2], disp );

	PDW_SetDrawDisp( SysWin[win_no].dobj[3], disp );
	PDW_SetDrawDisp( SysWin[win_no].dobj[4], disp );
	PDW_SetDrawDisp( SysWin[win_no].dobj[5], disp );

	PDW_SetDrawDisp( SysWin[win_no].dobj[6], disp );
	PDW_SetDrawDisp( SysWin[win_no].dobj[7], disp );
	PDW_SetDrawDisp( SysWin[win_no].dobj[8], disp );

	PDW_SetDrawDisp( SysWin[win_no].dobj[9], disp );

	return TRUE;
}

BOOL PST_LayerSystemWindow( int win_no, int layer )
{
	SysWin[win_no].layer = layer;

	PDW_SetDrawLayer( SysWin[win_no].dobj[9], layer+1 );

	PDW_SetDrawLayer( SysWin[win_no].dobj[0], layer );
	PDW_SetDrawLayer( SysWin[win_no].dobj[1], layer );
	PDW_SetDrawLayer( SysWin[win_no].dobj[2], layer );

	PDW_SetDrawLayer( SysWin[win_no].dobj[3], layer );
	PDW_SetDrawLayer( SysWin[win_no].dobj[4], layer );
	PDW_SetDrawLayer( SysWin[win_no].dobj[5], layer );

	PDW_SetDrawLayer( SysWin[win_no].dobj[6], layer );
	PDW_SetDrawLayer( SysWin[win_no].dobj[7], layer );
	PDW_SetDrawLayer( SysWin[win_no].dobj[8], layer );


	return TRUE;
}

//VXeEChE쐬
BOOL PST_NameSystemWindow( int win_no, char *wname, int fsize )
{
	int	sy=0;

	SysWin[win_no].wname = wname;
	if(fsize)	sy = -fsize/2+1;
	else		sy = -2;
	PDW_ResetDraw( &SysWin[win_no].dobj[9] );
	if(wname){
		PDW_SetDrawText( &SysWin[win_no].dobj[9], wname, SysWin[win_no].x+5, SysWin[win_no].y+sy, fsize, 0x00, SysWin[win_no].disp, SysWin[win_no].layer+1 );
		PDW_SetDrawColor( SysWin[win_no].dobj[9], COLOR_BLACK, COLOR_WHITE );
	}else{
		PDW_ResetDraw( &SysWin[win_no].dobj[9] );
	}
	if(wname && fsize!=0){
		PDW_SetDrawDestRect( SysWin[win_no].dobj[1], SysWin[win_no].x+5,   SysWin[win_no].y, SysWin[win_no].w-8, 4 );
	}else{
		PDW_SetDrawDestRect( SysWin[win_no].dobj[1], SysWin[win_no].x+4,   SysWin[win_no].y, SysWin[win_no].w-8, 4 );
	}

	return TRUE;
}

